/*
auteur: Pierre Bénet
dernière mise à jour: 21/09/2017

Voilà un exemple qui montre un peu comment faire fonctionner cette petite librairie
Il n'y a pas de fonction "protégées" comme présentées dans l'article, 
si la position demandée est hors du cube, la position est changée pour rentrée dans le cube.

compilation:
g++ test.cpp

execution:
./a.out

*/


#include "octree.h"
#include "vect3f.h"
#include <stdio.h>

int main(){
	
	Octree<int> oct;// octree sur des entiers
	Traceur<int> trac(oct);// traceur d'octree sur les entier
	
	
	
	trac.writeoct(Vect3f(.5,.0,.4),20);// dans l'arbre : crée une feuille à une profondeur de 10, (donc exposant de 20)
	// Au passage crée 80 éléments (les pères récursifs et leur voisins)
	
	int i;
	
	
	i=0;
	trac.firstcube();
	while(trac.nextcube()){
		i++;
		trac.getnode() = 12;// on met le chiffre 12 à tout les éléments de l'arbre
		/* il ne faut pas faire d'opérations de recherche avec le traceur
		lorsqu'on l'utilise pour parcourir l'arbre (sinon on risque de créer une boucle infinie...)
		*/
	}
	printf("nombre d'éléments: %d\n",i);
	
	i=0;
	trac.firstlastcube();
	while(trac.nextlastcube()){
		i++;
		trac.getnode() = 14;// on met le chiffre 14 à toute les feuilles de l'arbre
		/* il ne faut pas faire d'opérations de recherche avec le traceur
		lorsqu'on l'utilise pour parcourir l'arbre (sinon on risque de créer une boucle infinie...)
		*/
	}
	printf("nombre de feuilles: %d\n",i);
	
	
	trac.lastcube(Vect3f(.5,.0,.4));// positionne le traceur à la position Vect3f(.5,.0,.5)
	printf("chiffre dans la feuille à la position (.5,.0,.4) : %d\n",trac.getnode());
	printf("chiffre dans le père de la feuille à la position (.5,.0,.4) : %d\n\n",trac.getnode(trac.getexp()+1));


	return 0;
}
