#ifndef VECT3F_H
#define VECT3F_H

#include <stdio.h>

class Vect3f{
    public:

    inline Vect3f(){x=y=z=0;}
    inline Vect3f(float a,float b, float c){x=a;y=b;z=c;}
    inline float operator[](int i)const{return ((float*)this)[i];}
    inline float& operator[](int i){return ((float*)this)[i];}


    inline void print (const char* nom) const
    {printf("%s : %f %f %f \n",nom,x,y,z);}

    inline void operator+=(Vect3f const&a){x+=a.x;y+=a.y;z+=a.z;}
    inline void operator-=(Vect3f const&a){x-=a.x;y-=a.y;z-=a.z;}
    inline void operator*=(float a){x*=a;y*=a;z*=a;}

    float x;
    float y;
    float z;
};
inline Vect3f operator+(Vect3f const&a,Vect3f const&b){Vect3f c(a);c+=b;return c;}
inline Vect3f operator-(Vect3f const&a,Vect3f const&b){Vect3f c(a);c-=b;return c;}

inline Vect3f operator-(Vect3f const& a){return Vect3f(-a.x,-a.y,-a.z);}

inline Vect3f operator*(float a,Vect3f const& b){Vect3f v(b);v*=a;return v;}
inline float operator*(Vect3f const& a,Vect3f const& b){return a.x*b.x+a.y*b.y+a.z*b.z;}

inline Vect3f vectorielle(Vect3f const& a,Vect3f const& b){
    return Vect3f(
        a.y*b.z-a.z*b.y,
        b.x*a.z-b.z*a.x,
        a.x*b.y-a.y*b.x);
}
inline Vect3f operator^(Vect3f const& a,Vect3f const& b){
    return Vect3f(
        a.y*b.z-a.z*b.y,
        b.x*a.z-b.z*a.x,
        a.x*b.y-a.y*b.x);
}
inline Vect3f doubleproduit(Vect3f const& a,Vect3f const& b,Vect3f const& c){
    return (a*c)*b-(a*b)*c;
}


#endif
